#! /usr/bin/env python
# Incremental FreeBSD ports /usr/ports/INDEX file generator
#
# http://home.tiscali.cz/~cz210552/
# (c) Radim Kolar 2004, GPL

import os
import sys
import freebsdports

def buildINDEX(ports,output):
    badlist={}
    dupelist={}
    dupes=0
    for p in ports.values():
        if isinstance(p,freebsdports.portdescription):
            if p.name is None:
                del ports[p.path]
                continue
            if p.name in dupelist:
                print "Duplicate entry",p.name,"in both",p.path,"and",dupelist[p.name]
                dupes+=1
                continue # portsdb do not likes dupes
            dupelist[p.name]=p.path
            output.write( ("%s|%s|%s|%s|%s|%s|%s|") % (p.name,p.path,p.prefix,p.comment,p.dfile,p.maintainer,p.categories))
            output.write( "%s|%s|%s\n" % (freebsdports.directoriesToNames(p.bdeps,ports,badlist),freebsdports.directoriesToNames(p.rdeps,ports,badlist),p.www))
    print len(dupelist),'total entries'
    print dupes,"duplicated entries discarded"
    print len(badlist),"ports with unresolved depends kept"

INDEX=freebsdports.PORTS+"/INDEX"
if os.uname()[2][0]=='5':
   INDEX+="-5"

if __name__=="__main__":
    if len(sys.argv)>1:
        print sys.argv[0],"takes currently no arguments"
        sys.exit(1)
    allports=freebsdports.loadState()
    freebsdports.updatePortsInfo(allports)
    freebsdports.saveState(allports)
    freebsdports.expandAllDepends(allports)
#generate INDEX in debug destination
#INDEX="INDEX"
    print "Building",INDEX
    f=file(INDEX,"w")
    buildINDEX(allports,f)
    f.close()
