#! /usr/bin/env python
# Lists minor version updates in ports tree
# Version 2
# Coded by Radim Kolar http://home.tiscali.cz/~cz210552/
#
#
# Public domain
import os
import bsdpkg
import re

COMMAND="portversion -Ov -l \<"
PORTUPGRADE="portupgrade -kv "
#xscreensaver-gnome-4.15_2   <  needs updating (port has 4.16)
REGEX=r"^(\S+)-(\S+)\s+<\s+needs updating \(port has (\S+)\)"

def readportversions():
    versions=[]
    prog=re.compile(REGEX)
    pipe=os.popen(COMMAND)
    for line in pipe.readlines():
        res=prog.match(line)
        if res:
            versions.append( (res.group(1),res.group(2),res.group(3)) )
        else:
           print "Error parsing line:",line
           return None     
    pipe.close()
    return versions

def listminorupdates(versions):
    "Print minor updates on the screen and return package names"
    updates=[]
    disp=[]
    for v in versions:
      n1,v1,r1,e1 = bsdpkg.parsepkgname(v[0]+'-'+v[1])
      n2,v2,r2,e2 = bsdpkg.parsepkgname(v[0]+'-'+v[2])
      if v1 == v2:
          #print type(n1),type(v1),type(r1),type(r2)
          disp.append(n1+'-'+v1+'_'+(r1 or '0')+" -> "+(r2 or 'NONE??'))
          updates.append(n1)
    disp.sort();
    p=None
    for entry in disp:
        if p:
            print p+entry
            p = None
        else:
           l=len(entry)
           entry+=(78//2-l)*' '
           p =  entry
    if p : print p        
    return updates        

if __name__ == '__main__':          
    upd=listminorupdates(readportversions())
    if len(upd)>0:
        print "Found",len(upd),"packages with minor FreeBSD port version update."
        if False:
            print "Should I run:",PORTUPGRADE+" ".join(upd)+" (Y/n)?"
            ok=raw_input()
            if  ok=='Y':
                os.system(PORTUPGRADE+" ".join(upd))
            else:
                print "Not running portupgrade."        
