#! /usr/bin/env python
import sys
import pg

from loadindex import DATABASE
from freebsdports import PORTLEN,PORTS


def show_versions(c,pkg):
    query='SELECT * FROM packages WHERE '
    if '/' in pkg:
        query+='pkgdir=\''+PORTS+'/'
    else:
        query+='package=\''    
    query+=pkg+'\''
    q=c.query(query)
    if q.ntuples()==0:
       print "Package",pkg,"not found in database."
       q=c.query('SELECT distinct package,descr FROM packages WHERE package like \'%'+pkg+'%\'')
       if(q.ntuples()>0):
          print "See also:"
	  for result in q.dictresult():
	     print " ",result['package'],result['descr']
       return
    if q.ntuples()>1:
        print "Please choose one of",pkg,"packages available"
        for result in q.dictresult():
            print " ",result['pkgdir'][PORTLEN+1:],result['descr']
        return       
    res=q.dictresult()[0]
    if res['install']=='f':
        print "Package",pkg,"is not installed."
	inst=0
    else:
	  inst=1
	  q=c.query("SELECT 'now'-MAX(installed) FROM versions WHERE packageid="+str(res['id']))
	  res2=q.getresult()
	  if res2[0][0]:
	      print "Package",pkg,"was installed",res2[0][0],"days ago."
	  else:
	      print "Package",pkg,"is installed."
	      inst=0

    #report available versions
    q=c.query('SELECT * FROM versions WHERE packageid='+str(res['id'])+' ORDER BY released DESC')
    res2=q.dictresult()
    for result in res2:
       print "pkg",pkg,result['version'],result['released'],
       if result['installed']:
          print " ( installed",result['installed'],')'
       else:
          print
    #check if package can go into testing. It must be at least 14 days OLD
    q=c.query("SELECT 'now'-MAX(released) FROM versions WHERE packageid="+str(res['id']))
    res2=q.getresult()
    print "Latest available version of",pkg,"is",res2[0][0],"days old."
    if inst:
	q=c.query("SELECT 'now'-released FROM versions WHERE packageid="+str(res['id'])+" AND installed=(SELECT MAX(installed) FROM versions WHERE packageid="+str(res['id'])+");")
	res2=q.getresult()
	print "Installed version is",res2[0][0],"days old."

if __name__ == '__main__':
    c=pg.connect(DATABASE)
    for pkgname in sys.argv[1:]:
           if pkgname[0] == '-':
	      for opt in pkgname[1:]:
		  print "Unrecognised option",opt
	      continue
	   show_versions(c,pkgname)
    c.close()
