#! /usr/bin/env python
# Updates both index and readme
#
# Public domain
import os
import sys
import freebsdports
import indexer
import updatereadmes

if __name__ == '__main__':
    if len(sys.argv)>1:
        print sys.argv[0],"takes currently no arguments"
        sys.exit(1)
    allports=freebsdports.loadState()
    freebsdports.updatePortsInfo(allports)
    freebsdports.saveState(allports)
    freebsdports.expandAllDepends(allports)
    print "Building",indexer.INDEX
    f=file(indexer.INDEX,"w")
    indexer.buildINDEX(allports,f)
    f.close()
    updatereadmes.loadTemplates()
    updatereadmes.updateCategories(allports)
    os.path.walk(freebsdports.PORTS,updatereadmes.checkForOutdatedReadme,allports)
