#! /usr/bin/env python
#Updates installation status information in database
# 1) packages.install status field
# 2) packages -> version.installed date field
# 3) packages -> version.released date field to past

from loadindex import DATABASE

import pg
import os
from loadindex import pkg
from loadindex import db_loadpkg
import bsdpkg
import sys

#vrati seznam instalovanych pkg ziskanych z db
def getinstalledfromdb(c):
    q=c.query('SELECT pkgdir FROM packages WHERE install IS TRUE')
    list=[]
    for p in q.getresult():
      list.append(p[0])
    return list

#vrati hashtabulku package:datum kdy byl dany balik instalovan
def getinstalledfromfs():
    return bsdpkg.loadoriginsfromfs()

#vrati hashtabulku origin:verze
def getinstalledversionfromdpkg():
    return bsdpkg.loadoriginsversions()

def updateinstalledstatus(c,dblist,fslist):
    c.query('BEGIN TRANSACTION')
    new=0
    old=0
    local=0
    #step 1 - add missing
    for pkg in fslist.keys():
        if not pkg in dblist:
	   c.query("UPDATE packages SET install=TRUE WHERE pkgdir='"+pkg+"'")
	   dblist.append(pkg)
	   new+=1
    #step 2 - remove old
    for pkg in dblist:
        if not fslist.has_key(pkg):
	   c.query("UPDATE packages SET install=FALSE WHERE pkgdir='"+pkg+"'")
	   old+=1
    local=len(dblist)-len(getinstalledfromdb(c))
    new-=local
    print " Packages:",new,"new",old,"removed",local,"local."
    c.query('END')

def updateversionstatus(c,fslist,vrs):
    c.query('BEGIN TRANSACTION')
    for p in fslist.keys():
       if not vrs.has_key(p): continue
       entry=db_loadpkg(c,p,vrs[p])
       if not entry:
          print "Can't find version",vrs[p],"of package",p
          entry=db_loadpkg(c,p)
          if entry is None or \
             len(entry)==0: 
	            continue
          entry=entry[-1]
          entry.version=vrs[p]
          print "new version created" 
       entry.installed=fslist[p]
       entry.savetodb(c,False)
    c.query('END')

if __name__ == "__main__":
    if len(sys.argv)>1:
          print sys.argv[0],"takes currently no arguments"
          sys.exit(1)
    c=pg.connect(DATABASE)
    c.query('SET DateStyle=ISO');
    ifs=getinstalledfromfs()
    print len(ifs),"installed packages found in db/pkg database."
    idb=getinstalledfromdb(c)
    print "Updating package's install flag in database..."
    updateinstalledstatus(c,idb,ifs)
    print "Getting installed versions from db/pkg database..."
    vrs=getinstalledversionfromdpkg()
    print "Updating versions dates in database..."
    updateversionstatus(c,ifs,vrs)

    c.close()
